import { Runtype } from './runtype';
export declare const stringAsIntegerRuntype: Runtype<number>;
/**
 * A string that is parsed as an integer.
 *
 * Parsing is strict, e.g leading/trailing whitespace or leading zeros will
 * result in an error. Exponential notation is not allowed. The resulting
 * number must be a safe integer (`Number.isSafeInteger`).
 * A leading '+' or '-' is allowed.
 *
 * Options:
 *
 *   min .. reject numbers smaller than that
 *   max .. reject number larger than that
 */
export declare function stringAsInteger(options?: {
    min?: number;
    max?: number;
}): Runtype<number>;
